Dirac Video Codec

# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::PixelMatcher Class Reference

`#include <pixel_match.h>`

Collaboration diagram for dirac::PixelMatcher:
[legend]

List of all members.

## Public Member Functions

- PixelMatcher (const EncoderParams &encp)
    Constructor.
- void DoSearch (EncQueue &my_buffer, int pic_num)
    Do the actual search.

## Private Member Functions

- void MakePicHierarchy (const PicArray &data, OneDArray< PicArray * > &down_data)
    Make down-converted pictures.
- void MakeMEDataHierarchy (const OneDArray< PicArray * > &down_data, OneDArray< MEData * > &me_data_set)
    Make a hierarchy of MvData structures.
- void TidyPics (OneDArray< PicArray * > &down_data)
    Tidy up the allocations made in building the picture hirearchy.
- void TidyMEData (OneDArray< MEData * > &me_data_set)
    Tidy up the allocations made in building the MV data hirearchy.
- void MatchPic (const PicArray &ref_data, const PicArray &pic_data, MEData &me_data, const MvData &guide_data, const int ref_id)
    Match the picture data.
- void DoBlock (const int xpos, const int ypos, const MvArray &guide_array, BlockMatcher &block_match)
    Do a given block.

## Private Attributes

- const EncoderParams & m_encparams
    Local reference to the encoder params.
- const PicturePredParams * m_predparams
    Local reference to the picture pred params.
- int m_depth
- int m_level
- int m_xr
- int m_yr
- int m_big_xr
- int m_big_yr
- int m_tdiff [2]
- PictureSort m_psort
- CandidateList m_cand_list
- MVector m_mv_prediction
- double m_rho
- double m_cost_mean
- double m_cost_mean_sq

## Constructor & Destructor Documentation

dirac::PixelMatcher::PixelMatcher | ( | const EncoderParams & | encp | ) |

## Member Function Documentation

void dirac::PixelMatcher::DoSearch | ( | EncQueue & | my_buffer,
|  | int | pic_num |
| ) |  |  |

void dirac::PixelMatcher::MakePicHierarchy | ( | const PicArray & | data,
|  | OneDArray< PicArray * > & | down_data |
| ) |  |  | `[private]`

void dirac::PixelMatcher::MakeMEDataHierarchy | ( | const OneDArray< PicArray * > & | down_data,
|  | OneDArray< MEData * > & | me_data_set |
| ) |  |  | `[private]`

void dirac::PixelMatcher::TidyPics | ( | OneDArray< PicArray * > & | down_data | ) | `[private]`

void dirac::PixelMatcher::TidyMEData | ( | OneDArray< MEData * > & | me_data_set | ) | `[private]`

void dirac::PixelMatcher::MatchPic | ( | const PicArray & | ref_data,
|  | const PicArray & | pic_data,
|  | MEData & | me_data,
|  | const MvData & | guide_data,
|  | const int | ref_id |
| ) |  |  | `[private]`

void dirac::PixelMatcher::DoBlock | ( | const int | xpos,
|  | const int | ypos,
|  | const MvArray & | guide_array,
|  | BlockMatcher & | block_match |
| ) |  |  | `[private]`

## Member Data Documentation

const EncoderParams& dirac::PixelMatcher::m_encparams`[private]`

const PicturePredParams* dirac::PixelMatcher::m_predparams`[private]`

int dirac::PixelMatcher::m_depth`[private]`

int dirac::PixelMatcher::m_level`[private]`

int dirac::PixelMatcher::m_xr`[private]`

int dirac::PixelMatcher::m_yr`[private]`

int dirac::PixelMatcher::m_big_xr`[private]`

int dirac::PixelMatcher::m_big_yr`[private]`

int dirac::PixelMatcher::m_tdiff[2]`[private]`

PictureSort dirac::PixelMatcher::m_psort`[private]`

CandidateList dirac::PixelMatcher::m_cand_list`[private]`

MVector dirac::PixelMatcher::m_mv_prediction`[private]`

double dirac::PixelMatcher::m_rho`[private]`

double dirac::PixelMatcher::m_cost_mean`[private]`

double dirac::PixelMatcher::m_cost_mean_sq`[private]`

The documentation for this class was generated from the following file:

- pixel_match.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.